#include <stdio.h>
#include <assert.h>
#include <vector>

FILE *in = fopen("cogwheels.in", "r");

int ggt(int a, int b) {
	int tmp;
	do {
		tmp = a; a = b; b = tmp % b;
	}
	while (b > 0);
	return a;
}


int nom[21], denom[21];

void add(int x, int *vnom, int *vdenom) {
	if (nom[x] == 0) {
		vnom[x]++;
	}
	else {
		add(nom[x],   vnom, vdenom);
		add(denom[x], vdenom, vnom);
	}
}

bool solve(int x, int *vnom, int *vdenom) {
	if (x == 1) return true;

	while (1) {
		bool match = false;

		for (int i=2; i<=20;) {
			if (nom[i] != -1 && x%i == 0) {
				add(i, vnom, vdenom);
				x /= i;
				match = true;
				if (x == 1) return true;
			}
			else i++;
		}
		if (!match) break;
	}
	return false;
}

int main() {
	for (int N=1; ; N++) {
		int wheels[20];
		int n, min = 9999;

		for (int i=0; i<21; i++) nom[i] = -1;

		fscanf(in, "%d", &n);
		if (n==0) break;

		for (int i=0; i<n; i++) {
			int wheel;
			fscanf(in, "%d", &wheel);
			if (wheel < min) min = wheel;
			wheels[i] = wheel;
		}

		for (int i=0; i<n; i++) {
			int wheel = wheels[i] / min;
			nom[wheel] = 0;
		}

		while (1) {
			bool done = true;
			for (int i=1; i<21; i++) {
				if (nom[i] == -1) continue;
				for (int j=2; j<i; j++) {
					if (nom[j] == -1) continue;
					if (i%j == 0 && nom[i/j] == -1) {
						nom[i/j]   = i;
						denom[i/j] = j;
						done = false;
					}
				}
			}
			if (done) break;
		}
		
		printf("Set #%d\n", N);
		while(1) {
			int a, b;
			int vnom[21], vdenom[21];

			for (int i=0; i<21; i++) {
				vnom[i] = vdenom[i] = 0;
			}

			fscanf(in, "%d %d", &a, &b);
			if (a==0 && b==0) break;

			printf("Ratio %d:%d:", a, b);
			{
				int g = ggt(a, b);
				a /= g; b /= g;
			}

			if (solve(a, vnom, vdenom) && solve(b, vdenom, vnom)) {
				for (int i=1; i<21; i++) {
					int m = vnom[i]; if (vdenom[i] < m) m = vdenom[i];
					vnom[i] -= m;
					vdenom[i] -= m;
				}

				vector<int> xnom, xdenom;

				for (int i=1; i<21; i++) {
					for (int j=0; j<vnom[i]; j++) {
						xnom.push_back(i*min);
					}
				}
				for (int i=1; i<21; i++) {
					for (int j=0; j<vdenom[i]; j++) {
						xdenom.push_back(i*min);
					}
				}

				int diff = ((int) xnom.size()) - ((int) xdenom.size());
				if (diff > 0) {
					for (int i=0; i<diff; i++) xdenom.push_back(min);
				}
				else  {
					for (int i=0; i<-diff; i++) xnom.push_back(min);
				}

				if (xnom.size() == 0) {
					xnom.push_back(min);
					xdenom.push_back(min);
				}

				for (size_t i=0; i<xnom.size(); i++) {
					printf(" %d:%d", xnom[i], xdenom[i]);
				}
				printf("\n");
			}
			else {
				printf(" Impossible\n");
			}

		}
		printf("\n");
	}

	return 0;
}

