#include <stdio.h>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <queue>
#include <string.h>
#include <assert.h>

int main() {
	FILE *in = fopen("erdos.in", "r");
	
	for (int N=1; ; N++) {
		int p, n, id = 0;
		char buf[300], name[300], name2[300];
		set<string> names;
		map<string, int> ids;
		vector<int> links[10001];
		int dist[10001];

		names.insert("Erdos, P.");
		ids["Erdos, P."] = id++;

		fgets(buf, 300, in);
		sscanf(buf, "%d %d", &p, &n);
		if (n==0 && p==0) break;

		for (int i=0; i<p; i++) {
			bool done=false;
			int pos=0, r;
			int authors[100], nauths = 0;

			fgets(buf, 300, in);
			for (;!done;) {
				int cid;

				sscanf(buf+pos, "%[^,:],%n", name, &r); pos += r+1;
				sscanf(buf+pos, "%[^,:]%n", name2, &r); pos += r;

				string s(name);
				s += ", "; s += name2;

				if (buf[pos] == ',') pos+=2;
				else if (buf[pos] == ':') done = true;
				else assert(0);

				if (names.find(s) == names.end()) {
					names.insert(s);
					ids[s] = cid = id++;
				}
				else cid = ids[s];

				authors[nauths++] = cid;
			}

			for (int i=0; i<nauths; i++)
				for (int j=0; j<nauths; j++)
					if (i!=j) {
						links[authors[i]].push_back(authors[j]);
					}
		}

		{
			for (int i=0; i<10001; i++) dist[i] = -1;
			dist[0] = 0;

			queue<int> q;
			int cdist = 1;

			q.push(0);
			q.push(-1);

			while (q.size() > 1) {
				int cid = q.front(); q.pop();

				if (cid == -1) {
					cdist++;
					q.push(-1);
				}
				else {
					for (size_t i=0; i<links[cid].size(); i++) {
						int next = links[cid][i];
						if (dist[next] == -1) {
							dist[next] = cdist;
							q.push(next);
						}
					}
				}
			}
		}

		printf("Database #%d\n", N);
		for (int i=0; i<n; i++) {
			fgets(buf, 300, in);
			buf[strlen(buf)-1] = 0;

			if (names.find(buf) != names.end()) {
				int cid = ids[buf];
				int d = dist[cid];
				if (d >= 0) printf("%s: %d\n", buf, d);
				else printf("%s: infinity\n", buf);
			}
			else printf("%s: infinity\n", buf);
		}
	}

	return 0;
}

