#include <stdio.h>
#include <assert.h>

#define MAX (1 << 19)
#define ISSET(state, move) (((state) & (1 << ((move)-2))) != 0)
#define UNSET(state, move) ((state) &= ~(1 << ((move)-2)))
#define SET(state, move) ((state) |= (1 << ((move)-2)))

FILE *in = fopen("numbergame.in", "r");
short int win[MAX];

int apply(int state, int move) {
	UNSET(state, move);

	int fac, x;
	for (fac=1; fac*move <= 20; fac++) {
		x = fac*move;
		for (int i=2; i+x<= 20; i++) {
			if (!ISSET(state, i)) UNSET(state, i+x);
		}
	}

	return state;
}

bool iswin(int state) {
	if (win[state] != 0) return win[state] == 1;
	for (int i=2; i<=20; i++) {
		if (ISSET(state, i)) {
			int next = apply(state, i);
			if (!iswin(next)) {
				win[state] = 1;
				return true;
			}
		}
	}
	win[state] = -1;
	return false;
}

int main() {
	for (int i=0; i<MAX; i++) win[i] = 0;
	win[0] = -1;

	for (int N=1; ; N++) {
		int n, state = 0;
		int moves[20], cmoves = 0;
		
		fscanf(in, "%d", &n);
		if (n==0) break;

		for (int i=0; i<n; i++) {
			int x;
			fscanf(in, "%d", &x);
			SET(state, x);
		}

		for (int i=2; i<= 20; i++) {
			if (ISSET(state, i)) {
				int next = apply(state, i);
				if (!iswin(next)) moves[cmoves++] = i;
			}
		}

		printf("Test Case #%d\n", N);
		if (cmoves > 0) {
			printf("The winning moves are:");
			for (int i=0; i<cmoves; i++) {
				printf(" %d", moves[i]);
			}
			printf("\n\n");
		}
		else {
			printf("There's no winning move.\n\n");
		}
	}

	return 0;
}

