#include <stdio.h>
#include <math.h>
#include <assert.h>

#define MAXPRIME 40000

FILE *in = fopen("smith.in", "r");
int prime[6000], qprime[6000];

int qsum(int a) {
	int sum = 0;
	while (a > 0) {
		sum += a%10;
		a /= 10;
	}
	return sum;
}

bool issmith(int x) {
	int qs = qsum(x);
	int qf = 0;
	bool found = false;
	if (x == 1) return false;

	for (int i=0; prime[i];) {
		if (x % prime[i] == 0) {
			qf += qprime[i];
			x /= prime[i];
			found = true;
			if (x == 1) break;
		}
		else i++;
	}
	if (x > 1) qf += qsum(x);
	return found && (qf == qs);
}

int main() {

	{
		int nums[MAXPRIME];
		for (int i=0; i<MAXPRIME; i++) nums[i] = 0;
		int s = (int) sqrt(MAXPRIME);

		for (int i=2; i<=s; i++) {
			if (nums[i] == 0) {
				for (int j=2*i; j<MAXPRIME; j+=i) nums[j] = 1;
			}
		}

		int cnt=0;
		for (int i=2; i<MAXPRIME; i++) {
			if (nums[i] == 0) {
				prime[cnt++] = i;
			}
		}
		prime[cnt] = 0;
	}

	for (int i=0; prime[i]; i++) {
		qprime[i] = qsum(prime[i]);
	}

	while (1) {
		int x;
		fscanf(in, "%d", &x);
		if (x == 0) break;

		while (1) {
			if (issmith(++x)) {
				printf("%d\n", x);
				break;
			}
		}
	}

	return 0;
}

	
